package com.kamco.cd.training.auth;

import com.kamco.cd.training.common.enums.StatusType;
import com.kamco.cd.training.common.enums.error.AuthErrorCode;
import com.kamco.cd.training.common.exception.CustomApiException;
import com.kamco.cd.training.postgres.entity.MemberEntity;
import com.kamco.cd.training.postgres.repository.members.MembersRepository;
import lombok.RequiredArgsConstructor;
import org.mindrot.jbcrypt.BCrypt;
import org.springframework.security.authentication.AuthenticationProvider;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.stereotype.Component;

@Component
@RequiredArgsConstructor
public class CustomAuthenticationProvider implements AuthenticationProvider {

  private final MembersRepository membersRepository;

  @Override
  public Authentication authenticate(Authentication authentication) throws AuthenticationException {
    String username = authentication.getName();
    String rawPassword = authentication.getCredentials().toString();

    // 유저 조회
    MemberEntity member =
        membersRepository
            .findByEmployeeNo(username)
            .orElseThrow(() -> new CustomApiException(AuthErrorCode.LOGIN_ID_NOT_FOUND));

    // 미사용 상태
    if (member.getStatus().equals(StatusType.INACTIVE.getId())) {
      throw new CustomApiException(AuthErrorCode.LOGIN_ID_NOT_FOUND);
    }

    // jBCrypt + 커스텀 salt 로 저장된 패스워드 비교
    if (!BCrypt.checkpw(rawPassword, member.getPassword())) {
      // 실패 카운트 저장
      int cnt = member.getLoginFailCount() + 1;
      member.setLoginFailCount(cnt);
      membersRepository.save(member);
      throw new CustomApiException(AuthErrorCode.LOGIN_PASSWORD_MISMATCH);
    }

    // 로그인 실패 체크
    if (member.getLoginFailCount() >= 5) {
      throw new CustomApiException(AuthErrorCode.LOGIN_PASSWORD_EXCEEDED);
    }

    // 인증 성공 → UserDetails 생성
    CustomUserDetails userDetails = new CustomUserDetails(member);

    return new UsernamePasswordAuthenticationToken(userDetails, null, userDetails.getAuthorities());
  }

  @Override
  public boolean supports(Class<?> authentication) {
    return UsernamePasswordAuthenticationToken.class.isAssignableFrom(authentication);
  }
}
